<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 *
 */

//-- No direct access
defined('_JEXEC') || die('=;)');
jimport('joomla.filter.output');

$path_dropfilespluginbase = JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesPluginBase.php';
JLoader::register('DropfilesPluginBase', $path_dropfilespluginbase);

/**
 * Content Plugin.
 *
 * @package    dropfiles
 * @subpackage Plugin
 *
 *
 */
class PlgDropfilesthemesDefault extends DropfilesPluginBase
{
    /**
     * @var string
     */
    public $name = 'default';

    /**
     * Show front Category
     *
     * @param $options
     * @return null|string
     *
     */
    public function onShowFrontCategory($options)
    {
        $this->options = $options;
        if (@$this->options['theme'] != '' && $this->options['theme'] != $this->name) {
            return null;
        }
        $this->componentParams = JComponentHelper::getParams('com_dropfiles');
        $doc = JFactory::getDocument();

        JLoader::register('DropfilesBase', JPATH_ADMINISTRATOR . '/components/com_droppics/classes/dropfilesBase.php');
        JLoader::register('DropfilesHelper', JPATH_ADMINISTRATOR . '/components/com_dropfiles/helpers/dropfiles.php');
        JHtml::_('jquery.framework');
        $this->addScriptTagLoading();
        $doc->addScript(JURI::base('true') . '/components/com_dropfiles/assets/js/handlebars-v4.1.0.js');
        $doc->addScript(JURI::base('true') . '/components/com_dropfiles/assets/js/jaofoldertree.js');
        $doc->addStyleSheet(JURI::base('true') . '/components/com_dropfiles/assets/css/jaofoldertree.css');
        $iconic_font = JURI::base('true') . '/components/com_dropfiles/assets/css/material-design-iconic-font.min.css';
        $doc->addStyleSheet($iconic_font);
        $doc->addScript(JURI::base('true') . '/plugins/dropfilesthemes/default/js/script.js');
        $doc->addStyleSheet(JURI::base('true') . '/plugins/dropfilesthemes/default/style.css');

        $content = '';
        if (!empty($this->options['files']) || DropfilesBase::loadValue($this->params, 'showsubcategories', 1) == 1) {
            $this->files = $this->options['files'];
            $this->category = $this->options['category'];
            if ($this->category) {
                $this->category->alias = JFilterOutput::stringURLSafe($this->category->title);
            }
            $this->categories = $this->options['categories'];

            if (!in_array($this->name, parent::getDropfilesThemes())) {
                $this->params = $this->params->toObject();
            } else {
                $this->params = $this->options['params'];
            }

            if ((int) $this->componentParams->get('loadthemecategory', 1) === 1) {
                $this->params = $this->options['params'];
            }

            $this->viewfileanddowload = DropfilesBase::getAuthViewFileAndDownload();
            $canDo = DropfilesHelper::getActions();
            $this->user_id = null;
            if ((int)$canDo->get('core.edit')) {
                $this->user_id = JFactory::getUser()->id;
            }
            $this->urlmanage = JURI::root() . 'index.php?option=com_dropfiles&view=manage';

            $style = '.file,.dropfiles-content.dropfiles-content-default .dropfilescategory {margin : ';
            $style .= DropfilesBase::loadValue($this->params, 'margintop', 10) . 'px ';
            $style .= DropfilesBase::loadValue($this->params, 'marginright', 10) . 'px ';
            $style .= DropfilesBase::loadValue($this->params, 'marginbottom', 10) . 'px ';
            $style .= DropfilesBase::loadValue($this->params, 'marginleft', 10) . 'px !important;}';
            $style .= ' .dropfiles-content-default .file .downloadlink {background-color:';
            $style .= DropfilesBase::loadValue($this->params, 'bgdownloadlink', '#76bc58') . ' !important;color:';
            $style .= DropfilesBase::loadValue($this->params, 'colordownloadlink', '#fff') . ' !important;}';
            $doc->addStyleDeclaration($style);

            ob_start();
            require dirname(__FILE__) . DIRECTORY_SEPARATOR . 'tpl.php';
            $content = ob_get_contents();
            ob_end_clean();
        }
        return $content;
    }
}
