<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 */


//-- No direct access
defined('_JEXEC') || die('=;)');
DropfilesFilesHelper::includeJSHelper();
$usegoogleviewer = (DropfilesBase::loadValue($this->params, 'usegoogleviewer', 1) == 1) ? 'dropfileslightbox' : '';
$target = (DropfilesBase::loadValue($this->params, 'usegoogleviewer', 1) == 2) ? 'target="_blank"' : '';

$link_download_popup = '#';

?>
    <script type="text/javascript">
        <?php $allowedgoogleext = 'pdf,ppt,pptx,doc,docx,xls,xlsx,dxf,ps,eps,xps,psd,tif,tiff,bmp,svg,pages,ai,dxf,ttf'; ?>
        dropfilesGVExt = ["<?php echo implode('","', explode(',', DropfilesBase::loadValue($this->params, 'allowedgoogleext', $allowedgoogleext))); ?>"];
    </script>

    <script type="text/x-handlebars-template" id="dropfiles-template-ggd-box">
        {{#with file}}
        <div class="dropblock dropfiles-dropblock-content">
            <a href="#" class="dropfiles-close"></a>
            <div class="filecontent">
                {{#if custom_icon}}
                <div class="custom-icon {{ext}}"><img src="{{custom_icon_thumb}}" alt=""></div>
                {{else}}
                <div class="ext {{ext}}"><span class="txt">{{ext}}</div>
                {{/if}}
                <?php if (DropfilesBase::loadValue($this->params, 'ggd_showtitle', 1) == 1) : ?>
                    {{#if title}}
                    <h3><a class="downloadlink" href="{{link}}" title="{{title}}"><span>{{title}}</span></a></h3>
                    {{/if}}
                <?php endif; ?>
                <?php if (DropfilesBase::loadValue($this->params, 'ggd_showdescription', 1) == 1) : ?>
                    {{#if description}}
                    <div>{{{description}}}</div>
                    {{/if}}
                <?php endif; ?>
                <div class="dropfiles-extra">
                    <?php if (DropfilesBase::loadValue($this->params, 'ggd_showversion', 1) == 1) : ?>
                        {{#if versionNumber}}
                        <div><span>
                                <?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_VERSION'); ?>
                            </span>:&nbsp;{{versionNumber}}&nbsp;
                        </div>
                        {{/if}}
                    <?php endif; ?>
                    <?php if (DropfilesBase::loadValue($this->params, 'ggd_showsize', 1) == 1) : ?>
                        {{#if size}}
                        <div><span>
                                <?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_SIZE'); ?>
                            </span>:&nbsp;{{bytesToSizesize}}
                        </div>
                        {{/if}}
                    <?php endif; ?>
                    <?php if (DropfilesBase::loadValue($this->params, 'ggd_showhits', 1) == 1) : ?>
                        {{#if hits}}
                        <div><span><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_HITS'); ?></span>:&nbsp;{{hits}}
                        </div>
                        {{/if}}
                    <?php endif; ?>
                    <?php if (DropfilesBase::loadValue($this->params, 'ggd_showdateadd', 1) == 1) : ?>
                        {{#if created_time}}
                        <div><span>
                                <?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_SHOWDATEADD'); ?>
                            </span>:&nbsp;{{created_time}}
                        </div>
                        {{/if}}
                    <?php endif; ?>
                    <?php if (DropfilesBase::loadValue($this->params, 'ggd_showdatemodified', 0) == 1) : ?>
                        {{#if modified_time}}
                        <div><span>
                                <?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_DATEMODIFIED'); ?>
                            </span>:&nbsp;{{modified_time}}
                        </div>
                        {{/if}}
                    <?php endif; ?>
                </div>
            </div>
            <div class="extra-content">
                <?php if (DropfilesBase::loadValue($this->params, 'ggd_showdownload', 1) == 1) : ?>
                    <div class="extra-downloadlink">
                        <?php if ($this->viewfileanddowload) : ?>
                            {{#if remoteurl}}
                            <a href="{{link}}"
                               target="_blank"><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_DOWNLOAD'); ?><i
                                        class="zmdi zmdi-cloud-download dropfiles-download"></i></a>
                            {{else}}
                            <a href="{{link}}"><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_DOWNLOAD'); ?><i
                                        class="zmdi zmdi-cloud-download dropfiles-download"></i></a>
                            {{/if}}
                        <?php endif; ?>
                    </div>
                    <?php if (DropfilesBase::loadValue($this->params, 'usegoogleviewer', 1) > 0) : ?>
                        {{#if openpdflink}}
                        <div class="extra-openlink">
                            <a class="openlink" href="{{openpdflink}}"
                               target="_blank"><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_OPEN'); ?><i
                                        class="zmdi zmdi-filter-center-focus dropfiles-preview"></i></a>
                        </div>
                        {{else}}
                        {{#if viewerlink}}
                        <div class="extra-openlink">
                            <a data-id="{{id}}" data-catid="{{catid}}" data-file-type="{{ext}}"
                               class="openlink <?php echo $usegoogleviewer; ?>" <?php echo $target; ?>
                               href="{{viewerlink}}"><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_PREVIEW'); ?>
                                <i class="zmdi zmdi-filter-center-focus dropfiles-preview"></i></a>
                        </div>
                        {{/if}}
                        {{/if}}

                    <?php endif; ?>
                <?php endif; ?>
            </div>
        </div>
        {{/with}}
    </script>


<?php if (DropfilesBase::loadValue($this->params, 'ggd_showsubcategories', 1) == 1) : ?>
    <script type="text/x-handlebars-template" id="dropfiles-template-ggd-categories">
        <div class="dropfiles-categories">
            <?php if (DropfilesBase::loadValue($this->params, 'ggd_showcategorytitle', 1) == 1) : ?>
                {{#with category}}
                <div class="categories-head ">
                    <h2>{{title}}</h2>
                </div>
                {{/with}}
            <?php endif; ?>
            {{#with category}}
            {{#if parent_id}}
            <a class="catlink  dropfilescategory backcategory" href="#" data-idcat="{{parent_id}}">
                <i class="zmdi zmdi-chevron-left"></i><?php echo JText::_('COM_DROPFILES_DEFAULT_FRONT_BACK'); ?>
            </a>
            {{/if}}
            {{/with}}

            {{#if categories}}
            {{#each categories}}
            <a class="dropfilescategory catlink" href="#" data-idcat="{{id}}" title="{{title}}"><span>{{title}}</span>
                <i class="zmdi zmdi-folder dropfiles-folder"></i>
            </a>
            {{/each}}
            {{/if}}
        </div>
    </script>
<?php endif; ?>

    <script type="text/x-handlebars-template" id="dropfiles-template-ggd-files">
        {{#if files}}
        <div class="dropfiles_list">
            {{#each files}}{{#if ext}}
            <a
                    class="dropfiles-file-link"
                    title="{{title}}"
                    href="<?php
                    if (!$this->download_popup) {
                        echo '{{link_download_popup}}';
                    } else {
                        echo '#';
                    } ?>"
                    data-id="{{id}}">
                <div class="dropblock">
                    {{#if custom_icon}}
                    <div class="custom-icon {{ext}}"><img src="{{custom_icon_thumb}}" alt=""></div>
                    {{else}}
                    <div class="ext {{ext}}"><span class="txt">{{ext}}</div>
                    {{/if}}
                </div>
                <div class="droptitle">
                    {{title}}
                </div>
            </a>
            {{/if}}{{/each}}
        </div>
        {{/if}}
    </script>

<?php if (!empty($this->files) || !empty($this->categories)) : ?>
    <div class="dropfiles-content dropfiles-content-ggd dropfiles-content-multi dropfiles-files"
         data-category="<?php echo $this->category->id; ?>" data-current="<?php echo $this->category->id; ?>">
        <input type="hidden" id="current_category" value="<?php echo $this->category->id; ?>"/>
        <input type="hidden" id="current_category_slug" value="<?php echo $this->category->alias; ?>"/>
        <?php if (DropfilesBase::loadValue($this->params, 'ggd_showbreadcrumb', 1) == 1) : ?>
            <ul class="breadcrumbs dropfiles-breadcrumbs-ggd">
                <li class="active">
                    <?php echo $this->category->title; ?>
                </li>
                <?php if ($this->user_id) : ?>
                    <a data-id="" data-catid="" data-file-type="" class="openlink-manage-files " target="_blank"
                       href="<?php echo $this->urlmanage ?>" data-urlmanage="<?php echo $this->urlmanage ?>">
                        <?php echo JText::_('COM_DROPFILES_MANAGE_FILES'); ?><i
                                class="zmdi zmdi-edit dropfiles-preview"></i>
                    </a>
                <?php endif; ?>
            </ul>
        <?php endif; ?>
        <div class="dropfiles-container">
            <?php if (DropfilesBase::loadValue($this->params, 'ggd_showfoldertree', 0) == 1) : ?>
                <div class="dropfiles-foldertree dropfiles-foldertree-ggd">
                </div>
            <?php endif; ?>
            <div class="dropfiles-container-ggd <?php
            if (DropfilesBase::loadValue($this->params, 'ggd_showfoldertree', 0) == 1) {
                echo " with_foldertree";
            } ?>">
                <div class="dropfiles-categories">
                    <div class="categories-head ">
                        <?php if (DropfilesBase::loadValue($this->params, 'ggd_showcategorytitle', 1) == 1) : ?>
                            <h2><?php echo $this->category->title; ?></h2>
                        <?php endif; ?>
                    </div>
                    <?php
                    if (is_array($this->categories) && count($this->categories) &&
                        DropfilesBase::loadValue($this->params, 'ggd_showsubcategories', 1) == 1) :?>
                        <?php foreach ($this->categories as $category) : ?>
                            <a class="dropfilescategory catlink" href="#" data-idcat="<?php echo $category->id; ?>"
                               title="<?php echo $category->title; ?>">
                                <span><?php echo $category->title; ?></span>
                                <i class="zmdi zmdi-folder dropfiles-folder"></i>
                            </a>
                        <?php endforeach; ?>
                    <?php endif; ?>
                </div>
                <?php if (is_array($this->files) && count($this->files)) : ?>
                    <div class="dropfiles_list">
                        <?php foreach ($this->files as $file) : ?>
                            <?php if ($file->ext != null) : ?>
                                <a class="dropfiles-file-link"
                                   href="<?php echo $this->download_popup
                                       ? $link_download_popup : $file->link_download_popup; ?>"
                                   title="<?php echo $file->title; ?>" data-id="<?php echo $file->id; ?>">
                                    <div class="dropblock">
                                        <?php
                                        if ($this->componentParams->get('custom_icon', 1) == 1 &&
                                            $file->custom_icon != '') :
                                            ?>
                                            <div class="custom-icon <?php echo $file->ext; ?>">
                                                <img src="<?php echo $file->custom_icon_thumb; ?>" alt="">
                                            </div>
                                        <?php else : ?>
                                            <div class="ext <?php echo $file->ext; ?>">
                                            <span class="txt"><?php echo $file->ext; ?>
                                            </div>
                                        <?php endif; ?>
                                    </div>
                                    <div class="droptitle">
                                        <?php if (DropfilesBase::loadValue($this->params, 'ggd_showtitle', 1) == 1) : ?>
                                            <?php echo $file->title; ?>
                                        <?php endif; ?>
                                    </div>
                                </a>
                            <?php endif; ?>
                        <?php endforeach; ?>
                    </div>
                <?php endif; ?>
            </div>
        </div>
    </div>
<?php endif; ?>