<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien BarrÃ¨re (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 *
 */

// no direct access
defined('_JEXEC') or die;

/**
 * Class wpfdHelperResponse
 */
class ftsHelperResponse
{

    /**
     * @var array
     */
    protected $ftsResponse = array();

    /**
     * @param $msg
     */
    public function console($msg)
    {
        $this->ftsResponse[] = array('cn', $msg);
    }

    /**
     * @param $msg
     */
    public function alert($msg)
    {
        $this->ftsResponse[] = array('al', $msg);
    }

    /**
     * @param $id
     * @param $data
     */
    public function assign($id, $data)
    {
        $this->ftsResponse[] = array('as', $id, $data);
    }

    /**
     * @param string $url
     * @param int $delay
     */
    public function redirect($url = '', $delay = 0)
    {
        $this->ftsResponse[] = array('rd', $url, $delay);
    }

    /**
     *
     */
    public function reload()
    {
        $this->ftsResponse[] = array('rl');
    }

    /**
     * @param string $script
     */
    public function script($script = '')
    {
        $this->ftsResponse[] = array('js', $script);
    }

    /**
     * @param $var
     * @param $value
     */
    public function variable($var, $value)
    {
        $this->ftsResponse[] = array('vr', $var, $value);
    }

    /**
     * @param $a
     */
    public function setResponse($a)
    {
        $this->ftsResponse = $a;
    }

    /**
     * @return mixed|string|void
     */
    public function getJSON()
    {
        //@ini_set('error_reporting', 0);
        //@error_reporting(0);
        return json_encode($this->ftsResponse);
    }

    /**
     * @return array|bool|mixed|object
     */
    public function getData()
    {
        //@ini_set('error_reporting', 0);
        //@error_reporting(0);
        $input = JFactory::getApplication()->input;
        $xr = $input->post->getInt('__xr', null);
        if ($xr === 1) {
            $z = $input->post->get('z', null, null);
            $post = isset($z) ? json_decode(stripslashes($z), true) : array();
            return $post;
        } else {
            return false;
        }
    }
}
