<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 *
 */

defined('_JEXEC') or die;

jimport('joomla.form.formfield');

/**
 * Form Field class for the Joomla Framework.
 *
 */
class JFormFieldGooglebtn extends JFormField
{

    /**
     * @var string
     */
    protected $type = 'Googlebtn';

    /**
     * @return string
     */
    protected function getLabel()
    {

        return '';
    }

    /**
     * Add field connection Google drive
     *
     * @return string
     *
     */
    protected function getInput()
    {
        $path_dropfilesgoogle = JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesGoogle.php';
        JLoader::register('DropfilesGoogle', $path_dropfilesgoogle);

        $params = JComponentHelper::getParams('com_dropfiles');
        $google = new DropfilesGoogle();
        ob_start();
        echo '
            <style>
            .btn-google {
                background: #1d6cb0 none repeat scroll 0 0 !important;
                border: medium none !important;
                border-radius: 2px !important;
                box-shadow: none !important;
                height: auto !important;
                padding: 5px 20px !important;
                text-shadow: none !important;
                width: auto !important;
                color: #fff !important;
            }
            .google_node_head > h3{
                font-weight: bold;
                padding: 8px 0 7px 15px;
                background: ;
                background-color: #23282D;
                border-color: #bce8f1;
                color: #eee;
                font-size: 13px;
            }
            </style>
            ';
        if (!$params->get('google_client_id') || !$params->get('google_client_secret')) { ?>
            <?php JText::printf(
                'COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART1_1',
                'href="https://www.joomunited.com/documentation/dropfiles-documentation#toc-v-google-drive-integration" 
                target="__blank"'
            ); ?>

            <?php JText::printf(
                'COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART1_2',
                JURI::root(),
                JURI::root() . 'administrator/index.php?option=com_dropfiles&task=googledrive.authenticate'
            ); ?>

            <?php
            JText::printf(
                'COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART1_3',
                'href="#" onclick="window.parent.open(\'index.php?option=com_config&view=component&component=
                com_dropfiles&path=\',\'_self\');return false;"'
            );
            ?>

        <?php } elseif (!$google->checkAuth()) {
            $url = $google->getAuthorisationUrl();
            ?>
            <p><?php echo JText::_('COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART2'); ?></p>
            <p><a id="ggconnect" class="btn btn-primary btn-google" href="#"
                  onclick="window.open('<?php echo $url; ?>','foo','width=600,height=600');return false;"><img
                        src="<?php echo JURI::root(); ?>/components/com_dropfiles/assets/images/drive-icon-white.png"
                        alt="" width="13"/> <?php echo JText::_('COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART2_CONNECT'); ?>
                </a></p>
        <?php } else { ?>
            <?php echo JText::_('COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART3'); ?>
            <a class="btn btn-primary btn-google"
               href="index.php?option=com_dropfiles&task=googledrive.logout">
                <?php echo JText::_('COM_DROPFILES_GOOGLEDRIVE_CONNECT_PART3_DISCONNECT'); ?></a>
        <?php } ?>
        <?php
        return ob_get_clean();
    }
}
