<?php
/**
 * Dropfiles
 *
 * We developed this code with our hearts and passion.
 * We hope you found it useful, easy to understand and to customize.
 * Otherwise, please feel free to contact us at contact@joomunited.com *
 * @package Dropfiles
 * @copyright Copyright (C) 2013 JoomUnited (http://www.joomunited.com). All rights reserved.
 * @copyright Copyright (C) 2013 Damien Barrère (http://www.crac-design.com). All rights reserved.
 * @license GNU General Public License version 2 or later; http://www.gnu.org/licenses/gpl-2.0.html
 *
 */

// no direct access
defined('_JEXEC') or die;

/**
 * Class DropfilesControllerFrontgoogle
 */
class DropfilesControllerFrontgoogle extends JControllerLegacy
{

    /**
     * Google sync files
     */
    public function index()
    {
        $model = $this->getModel();
        $googleCats = $model->getAllGoogleCategories();
        $path_dropfilesgoogle = JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesGoogle.php';
        JLoader::register('DropfilesGoogle', $path_dropfilesgoogle);
        $google = new DropfilesGoogle();
        if ($google->checkAuth()) {
            $files_del = array();
            $gFilesInDb = $model->getAllGoogleFilesInDb();
            foreach ($googleCats as $googlecat) {
                $files = $google->listFilesInFolder($googlecat->cloud_id);
                if (isset($gFilesInDb[$googlecat->cloud_id])) {
                    $files_diff_add = array_diff_key($files, $gFilesInDb[$googlecat->cloud_id]);
                    $files_diff_del = array_diff_key($gFilesInDb[$googlecat->cloud_id], $files);
                    $files_update = array_intersect_key($files, $gFilesInDb[$googlecat->cloud_id]);
                } else {
                    $files_diff_add = $files;
                    $files_diff_del = array();
                    $files_update = array();
                }
                if (!empty($files_update)) {
                    foreach ($files_update as $file_id => $file) {
                        $localFileTime = strtotime($gFilesInDb[$googlecat->cloud_id][$file_id]->modified_time);
                        $need_update = false;
                        if ($localFileTime) {
                            if ($localFileTime < strtotime($file->modified_time)) {
                                $need_update = true;
                            }
                        } else {
                            $need_update = true;
                        }

                        if ($need_update) {
                            $data = array();
                            $data['id'] = $gFilesInDb[$googlecat->cloud_id][$file_id]->id;
                            $data['file_id'] = $file->id;
                            $data['ext'] = $file->ext;
                            $data['size'] = $file->size;
                            $data['title'] = $file->title;
                            // $data['description'] = $file->description;
                            $data['catid'] = $googlecat->cloud_id;
                            $data['modified_time'] = $file->modified_time;
                            $model->save($data);
                        }
                    }
                }
                if (!empty($files_diff_add)) {
                    //file exist in Google Drive without have in Dropfiles
                    foreach ($files_diff_add as $file_id => $file) {
                        $data = array();
                        $data['id'] = 0;
                        $data['file_id'] = $file->id;
                        $data['ext'] = $file->ext;
                        $data['size'] = $file->size;
                        $data['title'] = $file->title;
                        $data['description'] = $file->description;
                        $data['catid'] = $googlecat->cloud_id;
                        $data['created_time'] = $file->created_time;
                        $data['modified_time'] = $file->modified_time;
                        $data['file_tags'] = $file->file_tags;
                        $data['version'] = $file->version;
                        $data['hits'] = $file->hits;
                        $model->save($data);
                    }
                }
                if (!empty($files_diff_del)) {
                    $files_del = array_merge($files_del, array_keys($files_diff_del));
                }
            }
            if (!empty($files_del)) {
                $model->deleteFiles($files_del);
            }
        }
        die();
    }

    /**
     *sync google files in each category
     *
     */
    public function syncFiles($isCron = false, $step = 0)
    {
        $app = JFactory::getApplication();
        $model = $this->getModel();
        $googleCats = $model->getAllGoogleCategories();
        if (!$isCron) {
            $step = $app->input->getInt('step');
        }

        $path_drf_google = JPATH_ADMINISTRATOR . '/components/com_dropfiles/classes/dropfilesGoogle.php';
        JLoader::register('DropfilesGoogle', $path_drf_google);
        $google = new DropfilesGoogle();
        if ($google->checkAuth()) {
            $files_del = array();
            $gFilesInDb = $model->getAllGoogleFilesInDb();

            if (!isset($googleCats[$step])) {
                if (!$isCron) {
                    echo json_encode(array('continue' => false));
                } else {
                    return false;
                }

                $app->close();
            }
            $googlecat = $googleCats[$step];
            $files = $google->listFilesInFolder($googlecat->cloud_id);
            if (isset($gFilesInDb[$googlecat->cloud_id])) {
                $files_diff_add = array_diff_key($files, $gFilesInDb[$googlecat->cloud_id]);
                $files_diff_del = array_diff_key($gFilesInDb[$googlecat->cloud_id], $files);
                $files_update = array_intersect_key($files, $gFilesInDb[$googlecat->cloud_id]);
            } else {
                $files_diff_add = $files;
                $files_diff_del = array();
                $files_update = array();
            }


            if (!empty($files_update)) {
                foreach ($files_update as $file_id => $file) {
                    $localFileTime = strtotime($gFilesInDb[$googlecat->cloud_id][$file_id]->modified_time);
                    $need_update = false;
                    if ($localFileTime) {
                        if ($localFileTime < strtotime($file->modified_time)) {
                            $need_update = true;
                        }
                    } else {
                        $need_update = true;
                    }

                    if ($need_update) {
                        $data = array();
                        $data['id'] = $gFilesInDb[$googlecat->cloud_id][$file_id]->id;
                        $data['file_id'] = $file->id;
                        $data['ext'] = $file->ext;
                        $data['size'] = $file->size;
                        $data['title'] = $file->title;
                        // $data['description'] = $file->description;
                        $data['catid'] = $googlecat->cloud_id;
                        $data['modified_time'] = $file->modified_time;

                        $model->save($data);
                    }
                }
            }

            if (!empty($files_diff_add)) {
                //file exist in Google Drive without have in Dropfiles
                foreach ($files_diff_add as $file_id => $file) {
                    $data = array();
                    $data['id'] = 0;
                    $data['file_id'] = $file->id;
                    $data['ext'] = $file->ext;
                    $data['size'] = $file->size;
                    $data['title'] = $file->title;
                    $data['description'] = $file->description;
                    $data['catid'] = $googlecat->cloud_id;
                    $data['created_time'] = $file->created_time;
                    $data['modified_time'] = $file->modified_time;
                    $data['file_tags'] = $file->file_tags;
                    $data['version'] = $file->version;
                    $data['hits'] = $file->hits;
                    $model->save($data);
                }
            }

            if (!empty($files_diff_del)) {
                $files_del = array_merge($files_del, array_keys($files_diff_del));
            }


            if (!empty($files_del)) {
                $model->deleteFiles($files_del);
            }
        }

        $step++;
        if (isset($googleCats[$step])) {
            if (!$isCron) {
                echo json_encode(array('continue' => true));
            } else {
                return true;
            }

        } else {
            if (!$isCron) {
                echo json_encode(array('continue' => false));
            } else {
                return false;
            }
        }
        $app->close();
        die();
    }

    /**
     * Method get model
     * @param string $name
     * @param string $prefix
     * @param array $config
     * @return mixed
     */
    public function getModel(
        $name = 'frontgoogle',
        $prefix = 'dropfilesModel',
        $config = array('ignore_request' => true)
    ) {
        $model = parent::getModel($name, $prefix, $config);

        return $model;
    }
}
